
precision highp float;

uniform vec4 u_cc3CameraViewport;

uniform vec2 u_center;
uniform float u_radius;
uniform vec4 u_overlayColor;

varying vec2 v_texCoord;

void main() {
    vec2 fragPosition = v_texCoord * u_cc3CameraViewport.zw;
    vec2 delta = fragPosition - u_center;
    float outside = float(dot(delta, delta) > u_radius * u_radius);
    gl_FragColor = u_overlayColor * outside;
}
