precision highp float;

#define M_LOG2 1.442965

// uniforms
uniform sampler2D s_cc3Texture2Ds[2];
uniform vec4 u_cc3CameraFrustumDepth;

uniform float fogDensity;

// varyings
varying vec2 v_texCoord;
varying vec2 v_lightMapCoord;

// code
void main() {
    vec4 fogTexel = texture2D(s_cc3Texture2Ds[0], v_texCoord);
    vec4 lightMapTexel = texture2D(s_cc3Texture2Ds[1], v_lightMapCoord);

    float fogOpacity = fogTexel.a * lightMapTexel.r;

    float z = (gl_FragCoord.z / gl_FragCoord.w) / u_cc3CameraFrustumDepth[0];
    float fogFactor = clamp(1.0 - exp2(-M_LOG2 * fogDensity * fogDensity * z * z), 0.0, 1.0);

    gl_FragColor = vec4(fogTexel.rgb, fogOpacity * fogFactor);
}
