
precision highp float;

uniform sampler2D s_cc3Texture2D;
uniform vec4 u_cc3CameraViewport;
uniform float intensity;

#define OFFSET 1.3333333730697632

varying vec2 v_texCoord;

void main() {
#ifdef STAGE_X
    vec2 offset = vec2(OFFSET / u_cc3CameraViewport.p, 0.0);
#else
    vec2 offset = vec2(0.0, OFFSET / u_cc3CameraViewport.q);
#endif
    vec2 weights = vec2(0.29411765933036804, 0.3529411852359772) * intensity;

    vec4 fragColor = weights[0] * texture2D(s_cc3Texture2D, v_texCoord);

    fragColor += weights[1] * texture2D(s_cc3Texture2D, v_texCoord + offset);
    fragColor += weights[1] * texture2D(s_cc3Texture2D, v_texCoord - offset);

    gl_FragColor = fragColor;
}
