precision highp float;

attribute vec4 a_cc3Position;
attribute vec4 a_cc3Normal;
attribute vec4 a_cc3Color;
attribute vec2 a_cc3TexCoord0;

// uniforms
uniform mat4 u_cc3MatrixModel;
uniform mat4 u_cc3MatrixView;
uniform mat4 u_cc3MatrixProj;
uniform vec2 u_cc3SceneTime;
uniform vec4 u_cc3CameraPositionGlobal;
uniform float phaseDelay;
uniform vec2 windDirection;

varying vec2 v_texCoord;
varying vec2 a_texCoord;

float sanitize_time(float originalTime, float multiplier) {
    float moddedTime = mod(originalTime, 1.0 / multiplier);
    return moddedTime * multiplier;
}

void main() {
    vec4 globalPosition = u_cc3MatrixModel * a_cc3Position;
    gl_Position = u_cc3MatrixProj * u_cc3MatrixView * globalPosition;
    float dist = sanitize_time(u_cc3SceneTime[0], 0.1 * phaseDelay);
    v_texCoord = a_cc3TexCoord0 - 2.0 * vec2(dist * windDirection.x, dist * windDirection.y);
    a_texCoord = a_cc3TexCoord0;
}