
precision highp float;

uniform sampler2D s_cc3Texture2Ds[2];
uniform vec4 u_cc3CameraFrustum;

varying vec2 v_texCoord;

float linearize(float z) {
    float n = u_cc3CameraFrustum[2];    // Camera near clip distance
    float f = u_cc3CameraFrustum[3];    // Camera far clip distance
    float z_e = - n * f / (z * (f - n) - f);
    return (z_e - n) / (f - n);
}

void main() {
    vec4 texelColor = texture2D(s_cc3Texture2Ds[0], v_texCoord);
    vec4 texelDepth = texture2D(s_cc3Texture2Ds[1], v_texCoord);
    vec3 fogColor = vec3(1.0);

    float linearDepth = linearize(texelDepth.r);
    gl_FragColor = vec4(mix(texelColor.rgb, fogColor, linearDepth),
                        texelColor.a);
}
