
uniform bool u_shadowsEnabled;
uniform sampler2D u_shadowMap;
uniform float u_shadowIntensity;
uniform float u_shadowZThreshold;

varying float v_shadowDepth;
varying float v_shadowProj;
varying vec2 v_shadowCoord1;
varying vec2 v_shadowCoord2;
varying vec2 v_shadowCoord3;
varying vec2 v_shadowCoord4;

void shadow_receive() {
#ifdef SHADOWS_ENABLED
#ifndef SHADOWS_DISABLED
    vec3 shadowColor = vec3(1.0, 1.0, 0.7) * u_shadowIntensity;

    float shadowCoverage = 0.0;
    shadowCoverage += float(texture2DProj(u_shadowMap, vec3(v_shadowCoord1, v_shadowProj)).z < v_shadowDepth - u_shadowZThreshold);
    shadowCoverage += float(texture2DProj(u_shadowMap, vec3(v_shadowCoord2, v_shadowProj)).z < v_shadowDepth - u_shadowZThreshold);
    shadowCoverage += float(texture2DProj(u_shadowMap, vec3(v_shadowCoord3, v_shadowProj)).z < v_shadowDepth - u_shadowZThreshold);
    shadowCoverage += float(texture2DProj(u_shadowMap, vec3(v_shadowCoord4, v_shadowProj)).z < v_shadowDepth - u_shadowZThreshold);

    vec3 visibility = vec3(1.0) - shadowColor * shadowCoverage * 0.25 * float(u_shadowsEnabled);

    gl_FragColor.rgb *= visibility;
#endif
#endif
}
