
uniform mat4 u_shadowLightVP;
uniform float u_shadowPixelSize;

varying float v_shadowDepth;
varying float v_shadowProj;
varying vec2 v_shadowCoord1;
varying vec2 v_shadowCoord2;
varying vec2 v_shadowCoord3;
varying vec2 v_shadowCoord4;

void shadow_receive(vec4 position_world) {
#ifdef SHADOWS_ENABLED
#ifndef SHADOWS_DISABLED
    vec2 offsets[4];
    offsets[0] = vec2( -0.94201624, -0.39906216 );
    offsets[1] = vec2( 0.94558609, -0.76890725 );
    offsets[2] = vec2( -0.094184101, -0.92938870 );
    offsets[3] = vec2( 0.34495938, 0.29387760 );

    vec4 position_shadow = u_shadowLightVP * position_world;

    v_shadowProj = (2.0 * position_shadow.w);
    position_shadow.xyz += vec3(0.5) * v_shadowProj;

    v_shadowDepth = position_shadow.z / v_shadowProj;
    v_shadowCoord1 = position_shadow.xy + offsets[0] * u_shadowPixelSize * v_shadowProj;
    v_shadowCoord2 = position_shadow.xy + offsets[1] * u_shadowPixelSize * v_shadowProj;
    v_shadowCoord3 = position_shadow.xy + offsets[2] * u_shadowPixelSize * v_shadowProj;
    v_shadowCoord4 = position_shadow.xy + offsets[3] * u_shadowPixelSize * v_shadowProj;
#endif
#endif
}
