
precision highp float;

// uniforms
uniform sampler2D s_cc3Texture2Ds[1];
uniform vec3 u_cc3CameraPositionGlobal;

// varyings
varying vec3 v_N;
varying vec3 v_position_world;
varying vec2 v_texCoord;

// code
void main() {
    vec4 texel = texture2D(s_cc3Texture2Ds[0], v_texCoord);
    vec3 N = v_N;
    vec3 V = normalize(u_cc3CameraPositionGlobal - v_position_world);
    float nDotV = dot(N, V);

    vec3 refVector = vec3(1.0, 1.0, 0.0);
    float borderDirectionFalloff = pow(abs(dot(N, refVector)), 2.0);
    float borderRadialFalloff = pow(1.0 - nDotV, 4.0);
    vec4 border = vec4(0.5, 1.0, 0.7, borderRadialFalloff * borderDirectionFalloff);

    gl_FragColor = vec4(texel.rgb * texel.a * (1.0 - pow(nDotV, 4.0)) + border.rgb * border.a, 1);
}
