precision highp float;

// uniforms
uniform vec4 u_cc3MaterialDiffuseColor;
uniform vec4 u_cc3MaterialSpecularColor; // this is actually the color of the fresnel reflection

uniform sampler2D s_cc3Texture2Ds[4];

uniform samplerCube u_irradianceMap;

uniform vec3 u_cc3CameraPositionGlobal;
uniform vec2 u_cc3SceneTime;

// varyings
varying vec2 v_texCoord;
varying vec2 v_lightMapCoord;
varying vec4 v_vertexColor;

#if defined(USE_LIGHT)
varying vec3 v_N;
#endif

#include "shadow.fsh"

// code
void main() {
    vec4 diffuseTexel0 = texture2D(s_cc3Texture2Ds[0], v_texCoord);
    vec4 diffuseTexel1 = texture2D(s_cc3Texture2Ds[1], v_texCoord);
    vec4 diffuseTexel2 = texture2D(s_cc3Texture2Ds[2], v_texCoord);
    vec4 lightMapTexel = texture2D(s_cc3Texture2Ds[3], v_lightMapCoord);
    gl_FragColor = v_vertexColor.r * diffuseTexel0 + v_vertexColor.g * diffuseTexel1 + v_vertexColor.b * diffuseTexel2;

#ifdef USE_LIGHT
    gl_FragColor *= textureCube(u_irradianceMap, v_N);
#endif

    gl_FragColor *= lightMapTexel;

    shadow_receive();
}
